<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleMocoInverse.py</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_user.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For MATLAB, Python, Java, and C++ users</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleMocoInverse_8py-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleMocoInverse.py</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example using the MocoInverse tool with a complex model to prescribe walking. This example also shows how to track electromyography data.</p>
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"># OpenSim Moco: exampleMocoInverse.py                                        #</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"># Copyright (c) 2020 Stanford University and the Authors                     #</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"># Author(s): Christopher Dembia                                              #</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"># Licensed under the Apache License, Version 2.0 (the &quot;License&quot;) you may     #</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"># not use this file except in compliance with the License. You may obtain a  #</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"># copy of the License at http://www.apache.org/licenses/LICENSE-2.0          #</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"># Unless required by applicable law or agreed to in writing, software        #</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"># distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          #</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"># WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"># See the License for the specific language governing permissions and        #</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"># limitations under the License.                                             #</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"># This example shows how to use the MocoInverse tool to exactly prescribe a</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"># motion and estimate muscle behavior for walking. The first example does not</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"># rely on electromyography data, while the second example penalizes deviation</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"># from electromyography data for a subset of muscles.</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment">#</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"># See the README.txt next to this file for more information.</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">import</span> opensim <span class="keyword">as</span> osim</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160; </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">def </span>solveMocoInverse():</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    <span class="comment"># Construct the MocoInverse tool.</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    inverse = osim.MocoInverse()</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="comment"># Construct a ModelProcessor and set it on the tool. The default</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="comment"># muscles in the model are replaced with optimization-friendly</span></div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="comment"># DeGrooteFregly2016Muscles, and adjustments are made to the default muscle</span></div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="comment"># parameters.</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    modelProcessor = osim.ModelProcessor(<span class="stringliteral">&#39;subject_walk_armless.osim&#39;</span>)</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    modelProcessor.append(osim.ModOpAddExternalLoads(<span class="stringliteral">&#39;grf_walk.xml&#39;</span>))</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    modelProcessor.append(osim.ModOpIgnoreTendonCompliance())</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    modelProcessor.append(osim.ModOpReplaceMusclesWithDeGrooteFregly2016())</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="comment"># Only valid for DeGrooteFregly2016Muscles.</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    modelProcessor.append(osim.ModOpIgnorePassiveFiberForcesDGF())</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="comment"># Only valid for DeGrooteFregly2016Muscles.</span></div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    modelProcessor.append(osim.ModOpScaleActiveFiberForceCurveWidthDGF(1.5))</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    modelProcessor.append(osim.ModOpAddReserves(1.0))</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    inverse.setModel(modelProcessor)</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="comment"># Construct a TableProcessor of the coordinate data and pass it to the</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="comment"># inverse tool. TableProcessors can be used in the same way as</span></div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="comment"># ModelProcessors by appending TableOperators to modify the base table.</span></div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    <span class="comment"># A TableProcessor with no operators, as we have here, simply returns the</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="comment"># base table.</span></div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    inverse.setKinematics(osim.TableProcessor(<span class="stringliteral">&#39;coordinates.sto&#39;</span>))</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="comment"># Initial time, final time, and mesh interval.</span></div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    inverse.set_initial_time(0.81)</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    inverse.set_final_time(1.79)</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    inverse.set_mesh_interval(0.02)</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160; </div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="comment"># By default, Moco gives an error if the kinematics contains extra columns.</span></div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    <span class="comment"># Here, we tell Moco to allow (and ignore) those extra columns.</span></div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    inverse.set_kinematics_allow_extra_columns(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="comment"># Solve the problem and write the solution to a Storage file.</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    solution = inverse.solve()</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    solution.getMocoSolution().write(<span class="stringliteral">&#39;example3DWalking_MocoInverse_solution.sto&#39;</span>)</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="comment"># Generate a PDF with plots for the solution trajectory.</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    model = modelProcessor.process()</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    report = osim.report.Report(model,</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;                                <span class="stringliteral">&#39;example3DWalking_MocoInverse_solution.sto&#39;</span>,</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;                                bilateral=<span class="keyword">True</span>)</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="comment"># The PDF is saved to the working directory.</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    report.generate()</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="keyword">def </span>solveMocoInverseWithEMG():</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="comment"># This initial block of code is identical to the code above.</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    inverse = osim.MocoInverse()</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    modelProcessor = osim.ModelProcessor(<span class="stringliteral">&#39;subject_walk_armless.osim&#39;</span>)</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    modelProcessor.append(osim.ModOpAddExternalLoads(<span class="stringliteral">&#39;grf_walk.xml&#39;</span>))</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    modelProcessor.append(osim.ModOpIgnoreTendonCompliance())</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    modelProcessor.append(osim.ModOpReplaceMusclesWithDeGrooteFregly2016())</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    modelProcessor.append(osim.ModOpIgnorePassiveFiberForcesDGF())</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    modelProcessor.append(osim.ModOpScaleActiveFiberForceCurveWidthDGF(1.5))</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    modelProcessor.append(osim.ModOpAddReserves(1.0))</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    inverse.setModel(modelProcessor)</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    inverse.setKinematics(osim.TableProcessor(<span class="stringliteral">&#39;coordinates.sto&#39;</span>))</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    inverse.set_initial_time(0.81)</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    inverse.set_final_time(1.79)</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    inverse.set_mesh_interval(0.02)</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    inverse.set_kinematics_allow_extra_columns(<span class="keyword">True</span>)</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160; </div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    study = inverse.initialize()</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    problem = study.updProblem()</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="comment"># Add electromyography tracking.</span></div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    emgTracking = osim.MocoControlTrackingGoal(<span class="stringliteral">&#39;emg_tracking&#39;</span>)</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    emgTracking.setWeight(50.0)</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="comment"># Each column in electromyography.sto is normalized so the maximum value in</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="comment"># each column is 1.0.</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    controlsRef = osim.TimeSeriesTable(<span class="stringliteral">&#39;electromyography.sto&#39;</span>)</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <span class="comment"># Scale the tracked muscle activity based on peak levels from</span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <span class="comment"># &quot;Gait Analysis: Normal and Pathological Function&quot; by</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="comment"># Perry and Burnfield, 2010 (digitized by Carmichael Ong).</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    soleus = controlsRef.updDependentColumn(<span class="stringliteral">&#39;soleus&#39;</span>)</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    gasmed = controlsRef.updDependentColumn(<span class="stringliteral">&#39;gastrocnemius&#39;</span>)</div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    tibant = controlsRef.updDependentColumn(<span class="stringliteral">&#39;tibialis_anterior&#39;</span>)</div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <span class="keywordflow">for</span> t <span class="keywordflow">in</span> range(0, controlsRef.getNumRows()):</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;        soleus[t] = 0.77 * soleus[t]</div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        gasmed[t] = 0.87 * gasmed[t]</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        tibant[t] = 0.37 * tibant[t]</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    emgTracking.setReference(osim.TableProcessor(controlsRef))</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="comment"># Associate actuators in the model with columns in electromyography.sto.</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    emgTracking.setReferenceLabel(<span class="stringliteral">&#39;/forceset/soleus_r&#39;</span>, <span class="stringliteral">&#39;soleus&#39;</span>)</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    emgTracking.setReferenceLabel(<span class="stringliteral">&#39;/forceset/gasmed_r&#39;</span>, <span class="stringliteral">&#39;gastrocnemius&#39;</span>)</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    emgTracking.setReferenceLabel(<span class="stringliteral">&#39;/forceset/gaslat_r&#39;</span>, <span class="stringliteral">&#39;gastrocnemius&#39;</span>)</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    emgTracking.setReferenceLabel(<span class="stringliteral">&#39;/forceset/tibant_r&#39;</span>, <span class="stringliteral">&#39;tibialis_anterior&#39;</span>)</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    problem.addGoal(emgTracking)</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160; </div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <span class="comment"># Solve the problem and write the solution to a Storage file.</span></div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    solution = study.solve()</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    solution.write(<span class="stringliteral">&#39;example3DWalking_MocoInverseWithEMG_solution.sto&#39;</span>)</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160; </div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <span class="comment"># Write the reference data in a way that&#39;s easy to compare to the solution.</span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    controlsRef.removeColumn(<span class="stringliteral">&#39;medial_hamstrings&#39;</span>)</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    controlsRef.removeColumn(<span class="stringliteral">&#39;biceps_femoris&#39;</span>)</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    controlsRef.removeColumn(<span class="stringliteral">&#39;vastus_lateralis&#39;</span>)</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    controlsRef.removeColumn(<span class="stringliteral">&#39;vastus_medius&#39;</span>)</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    controlsRef.removeColumn(<span class="stringliteral">&#39;rectus_femoris&#39;</span>)</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    controlsRef.removeColumn(<span class="stringliteral">&#39;gluteus_maximus&#39;</span>)</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    controlsRef.removeColumn(<span class="stringliteral">&#39;gluteus_medius&#39;</span>)</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    controlsRef.setColumnLabels([<span class="stringliteral">&#39;/forceset/soleus_r&#39;</span>, <span class="stringliteral">&#39;/forceset/gasmed_r&#39;</span>,</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;                                 <span class="stringliteral">&#39;/forceset/tibant_r&#39;</span>])</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    controlsRef.appendColumn(<span class="stringliteral">&#39;/forceset/gaslat_r&#39;</span>, gasmed)</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    osim.STOFileAdapter.write(controlsRef, <span class="stringliteral">&#39;controls_reference.sto&#39;</span>)</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160; </div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    <span class="comment"># Generate a report comparing MocoInverse solutions without and with EMG</span></div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="comment"># tracking.</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    model = modelProcessor.process()</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    output = <span class="stringliteral">&#39;example3DWalking_MocoInverseWithEMG_report.pdf&#39;</span></div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    ref_files = [</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <span class="stringliteral">&#39;example3DWalking_MocoInverseWithEMG_solution.sto&#39;</span>,</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="stringliteral">&#39;controls_reference.sto&#39;</span>]</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    report = osim.report.Report(model,</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;                                <span class="stringliteral">&#39;example3DWalking_MocoInverse_solution.sto&#39;</span>,</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;                                output=output, bilateral=<span class="keyword">True</span>,</div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;                                ref_files=ref_files)</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    <span class="comment"># The PDF is saved to the working directory.</span></div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    report.generate()</div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160; </div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160; </div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;<span class="comment"># This problem solves in about 5 minutes.</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;solveMocoInverse()</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160; </div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="comment"># This problem penalizes the deviation from electromyography data for a</span></div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;<span class="comment"># subset of muscles, and solves in about 30 minutes.</span></div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;solveMocoInverseWithEMG()</div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:39 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
